/*
	Program Motionslb
	
	Et program til at registrerer og udregne lbetider for
	lberne i et motionslb.
	Der forudsttes at lberne medbringer et kort med nummer,
	navn, starttid og sluttid alle data indtastes ved mlstregen.
	P computerskrmen fremgr lbernes placering hele tiden.
	
	Bruger MotionsloebMain class'en
	Af Lars Hansen 30 oktober 1999
*/	


import javabook.*;

class Motionsloeb
{
	/**********************
			Data Members
	**********************/
	
	MainWindow 		mainWindow;
	InputBox 			inputBox;
	MultiInputBox mInputBox;	
	OutputBox 		outputBox;
	MessageBox 		messageBox;
	Loeber[]		loeber;
	int[]					liste;
	
	/**********************
			Constructor
	**********************/
	public Motionsloeb()
	{
		mainWindow = new MainWindow("Motionslb");
		inputBox = new InputBox(mainWindow, "Indtast antal lbere");
		outputBox	= new OutputBox(mainWindow, "Lbs resultater");
		messageBox = new MessageBox(mainWindow);
		inputBox.setSize(100, 300);
		mainWindow.show();
		
	}
	
	/**********************
			Public Methods
	**********************/

	
	public  void start()
	{
		int antalDeltagere		= inputBox.getInteger("Hvor mange lbere er der ? ");
		loeber = new Loeber[antalDeltagere + 1];
		
		
		indlaesning();
		
	}
	
	
	
	public void indlaesning() throws NumberFormatException
	{
		// F nummer, navn, start og sluttid p lber
		String[] s = {"Lber-nummer", "Navn","Start tidspunkt (HHMMSS)", "Slut tidspunkt (HHMMSS)"};
		String[] loeberData;
		mInputBox 		= new MultiInputBox(mainWindow, s);
		mInputBox.setTitle ("Indtast lber data");
		boolean okStart = false, okSlut = false;
		int nummer = 1;
		while (okStart == false || okSlut == false)
		{
			loeberData		= mInputBox.getInputs();
			if (loeberData == null) mInputBox.hide(); 
			try
			{		
				nummer = Integer.valueOf(loeberData[0].trim()).intValue();
			}
			catch (NumberFormatException e) 
			{
				System.out.println("Fejl i lbernummer");	//Temp.
				indlaesning();
			}
			loeber[nummer] = new Loeber();
			if (loeber[nummer].kontrolererTid(loeberData[2]))
			{
				loeber[nummer].setStartTid(loeberData[2]);
				okStart = true;
			}
			else
				messageBox.show("Der er fejl i start-tidspunktet, prv igen.");
				
			if (loeber[nummer].kontrolererTid(loeberData[3]))
			{
				loeber[nummer].setSlutTid(loeberData[3]);
				okSlut = true;
			}
			else
				messageBox.show("Der er fejl i slut-tidspunktet, prv igen.");
				
			System.out.println("Frdig med indlsning");
			loeber[nummer].setNavn(loeberData[1]);		
		}
		
		loeber[nummer].udregnTid();
		sorter();
		visResultat();		
		indlaesning();
	}
	
	public  void sorter()
	{
		Loeber temp;
		int valgt;
		
		for (int hurtigst = 0; hurtigst < loeber.length -1;hurtigst++)
		{
			valgt = hurtigst;
			for (int j = hurtigst +1;j < loeber.length ;j++)
				if (loeber[j] != null && loeber[valgt] != null)
					if (loeber[j].getUdregnetTidISek() < loeber[valgt].getUdregnetTidISek()) valgt = j;
			temp = loeber[valgt];
			loeber[valgt] = loeber[hurtigst];
			loeber[hurtigst] = temp;
		}
		
	}

	
	public  void visResultat()
	{
		outputBox.show();
		outputBox.clear();
		outputBox.printLine("Nummer \t"+"Navn \t\t"+
				"Start-tid \t"+ "Slut-tid \t"+ "Lbe-tid");
		outputBox.printLine
			("=========================================================================");
		for (int n = 0;n < loeber.length;n++)
		{ 
			if (loeber[n] != null)		
			outputBox.printLine(n +"\t"+loeber[n].getNavn()+"\t"+
				loeber[n].getStartTid()+"\t"+ loeber[n].getSlutTid() +
				"\t"+ loeber[n].getUdregnetTid());
		}

		
	}

}