/*
Class:					TidsUdregning.

Beskrivelse:		Et objekt af denne class bruges til at gemme
								information om en starttid, sluttid og kan udregne
								tiden imellem de to tider.
								Tiden kan leveres som string eller i sekunder.
								Class'en har en njagtighed p 1 sekund og kan kun 
								arbejde med tidspunkter inden for samme dgn.
								
								Af Lars Hansen 30 oktober 1999.
								
								
Public methods:	void 			setStartTid(String)
								void 			setSlutTid(String)
								boolean 	kontrolererTid(String)
								void 			udregnTid()
								String 		getStartTid()
								String 		getSlutTid()
								String 		getUdregnetTid()
								long 			getUdregnetTidISek()
*/


class TidsUdregning
{
	/**********************
			Data Members
	**********************/
	
		private long startTid, slutTid, udregnetTid;
	
	/**********************
			Constructor
	**********************/
	public void TidsUdregning()
	{
		startTid 	= 86400;
		slutTid 	= 86400;
		udregnetTid 	= 0;
	}
	
	/**********************
			Public Methods
	**********************/

	public void setStartTid(String sTid)
	{
		long t = Integer.valueOf(sTid.trim()).intValue();
		startTid = ((t / 10000)* 3600) + (((t % 10000) / 100) * 60) + (t % 100);
	}
	
	
	public void setSlutTid(String sTid)
	{
		long t = Integer.valueOf(sTid.trim()).intValue();
		slutTid = ((t / 10000)* 3600) + (((t % 10000) / 100) * 60) + (t % 100);
	}
	
	
	public boolean kontrolererTid(String sTid) throws NumberFormatException
	{
		// kontrolerer tidspunktet brugeren indtaster og returner false, hvis det ikke er ok
		String sTimer, sMinuter, sSekunder;
		int timer, minuter, sekunder;
		if (sTid.length() < 5) return false;
		String trimmetSTid = sTid.trim();
		try
			{
				sTimer 		= trimmetSTid.substring(0,2);
				sMinuter 	= trimmetSTid.substring(2,4);
				sSekunder = trimmetSTid.substring(4,6);
				timer 		= Integer.valueOf(sTimer).intValue();
				minuter 	= Integer.valueOf(sMinuter).intValue();
				sekunder 	= Integer.valueOf(sSekunder).intValue();
				
				System.out.println("Timer "+ timer +" Minuter "+minuter + " Sekunder "+ sekunder); //Temp.
				if (timer < 24 && minuter <= 60 && sekunder <= 60)
					return true;
				else
					return false;
			}
			catch (NumberFormatException e) 
			{
				System.out.println("Fejl i datokonvetering");	//Temp.
				return false;
			}
	
	}
	
	
	public void udregnTid()
	{
		udregnetTid =  slutTid - startTid; 
		System.out.println(udregnetTid);
	}
	
	

	
	public String getStartTid()
	{
		return tilString(startTid);
	}
	
		
	public String getSlutTid()
	{
		return tilString(slutTid);
	}
	
	
	public String getUdregnetTid()
	{
		return tilString(udregnetTid);
	}
	
	
	public long getUdregnetTidISek()
	{
		return udregnetTid;
	}

	
	
	
/**********************
			Private Methods
**********************/

	private String tilString(long tidSek)
	{
		Long t, m, s;
		String ti, mi, se;
		long timer, minuter, sekunder;
		timer = tidSek / 3600;
		minuter = (tidSek- (timer *3600)) / 60;
		sekunder =(tidSek- (timer *3600)- (minuter * 60));
		t = new Long(timer);
		m = new Long(minuter);
		s = new Long(sekunder);
		if (t.toString().length() < 2)
			ti = "0" + t.toString();
		else
			ti = t.toString();
			
		if (m.toString().length() < 2)
			mi = "0" + m.toString();
		else
			mi = m.toString();
			
		if (s.toString().length() < 2)
			se = "0" + s.toString();
		else
			se = s.toString();
				
		return ti +":"+ mi +":"+ se;
	}

}